package ormwork;

import static org.eclipse.persistence.config.PersistenceUnitProperties.JDBC_DRIVER;
import static org.eclipse.persistence.config.PersistenceUnitProperties.JDBC_PASSWORD;
import static org.eclipse.persistence.config.PersistenceUnitProperties.JDBC_URL;
import static org.eclipse.persistence.config.PersistenceUnitProperties.JDBC_USER;
import static org.eclipse.persistence.config.PersistenceUnitProperties.LOGGING_LEVEL;
import static org.eclipse.persistence.config.PersistenceUnitProperties.LOGGING_SESSION;
import static org.eclipse.persistence.config.PersistenceUnitProperties.LOGGING_THREAD;
import static org.eclipse.persistence.config.PersistenceUnitProperties.LOGGING_TIMESTAMP;
import static org.eclipse.persistence.config.PersistenceUnitProperties.TRANSACTION_TYPE;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManagerFactory;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Persistence;
import javax.persistence.Table;
import javax.persistence.spi.PersistenceUnitTransactionType;

@Entity
@Table(name = "DBJavaUsers")
public class JavaORMClass {
    
    @Id @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "IDENT_PARAMS_ID")
    private Long id;
    
    @Column(name = "name")
    private String name; 
    
    @Column(name = "fullname")
    private String fullName;
 
    @Column(name = "password")
    private String password;

    public JavaORMClass() {
    }

    public JavaORMClass(String name, String fullName, String password) {
        super();
        this.name = name;
        this.fullName = fullName;
        this.password = password;
    }

    public Long getId() {
        return id;
    }
    
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getFullName() {
        return fullName;
    }

    public void setFullName(String fullName) {
        this.fullName = fullName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }
    
    /**
     * @param args
     */
    public static void main(String[] args) {
        // TODO Auto-generated method stub
        
        /*
         * CREATE TABLE DBJavaUsers (
    id int unsigned not null auto_increment,
    name varchar(30) not null,
    fullname varchar(30) not null,
    password varchar(20) not null,
    PRIMARY KEY(id));
         * 
         */
     
        Properties properties = new Properties();
        Map<String, String> map = new HashMap<String, String>((Map) properties);
        
//        HashMap properties = new HashMap();
     
        // Ensure RESOURCE_LOCAL transactions is used.
        map.put(TRANSACTION_TYPE,
            PersistenceUnitTransactionType.RESOURCE_LOCAL.name());
     
        // Configure the internal EclipseLink connection pool
        map.put(JDBC_DRIVER, "com.mysql.jdbc.Driver");
        map.put(JDBC_URL, "jdbc:mysql://localhost/sqlAlchemyJavaORM");
        map.put(JDBC_USER, "userName");
        map.put(JDBC_PASSWORD, "pasword");
     
        // Configure logging. FINE ensures all SQL is shown
        map.put(LOGGING_LEVEL, "OFF");
        map.put(LOGGING_TIMESTAMP, "false");
        map.put(LOGGING_THREAD, "false");
        map.put(LOGGING_SESSION, "false");
     
        // Ensure that no server-platform is configured
//        properties.put(TARGET_SERVER, TargetServer.None);

//        EntityManagerFactory emf = Persistence.createEntityManagerFactory("JavaORMProject", map);

        ClientCreate clientCreate = new ClientCreate();
        
        long startTime = System.nanoTime();

        for (int i = 0; i < 100000; i++) {
            JavaORMClass javaORMClassObject = new JavaORMClass(
                    "ed" + i, "Ed Jones" + i, "password");
            clientCreate.saveJavaOrm(map, javaORMClassObject);
        }

        long endTime = System.nanoTime();
        long duration = endTime - startTime;
        System.out.println("Execution time: " + duration/1000000000);
    }
}
