import sqlalchemy
from sqlalchemy import create_engine
from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import Column, Integer, String
from sqlalchemy.orm import sessionmaker
import time

if __name__ == '__main__':
    sqlalchemy.__version__
#    engine = create_engine('sqlite:///:memory:', echo=True)
    engine = create_engine('mysql://userName:password@localhost', echo=False)
    # Only need to run the line below once
#    engine.execute('CREATE DATABASE sqlAlchemyJavaORM')
    engine.execute('USE sqlAlchemyJavaORM')
    Base = declarative_base()

    class User(Base):
        __tablename__ = 'DBPythonUsers'
        id = Column(Integer, primary_key=True, nullable = False)
        name = Column(String(30), nullable = False)
        fullname = Column(String(30), nullable = False)
        password = Column(String(20), nullable = False)
        
        def greeting(self):
            return 'Hello world from class name ' + self.__class__.__name__
        
        def __repr__(self):
            return "<User(name='%s', fullname='%s', password='%s')>" % (
                                                                        self.name, self.fullname, self.password)
    
    x = User()
    print x.greeting()
    Base.metadata.create_all(engine)
    Session = sessionmaker(bind=engine)
    session = Session()
    
    startTime = time.time()

    # Create an entity
    for i in range(0, 100000):
        ed_user = User(name='ed' + str(i), fullname='Ed Jones', password='edspassword')
        # Now we can talk to the database
        session.add(ed_user)

    session.commit()
    print time.time() - startTime, 'seconds'
